
/*
Copyright 2007-2008 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

var yarip = {
	MODES: {
		page: 0,
		fqdn: 1,
		sld: 2,
		user: 3
	},

	TYPE: {
		whitelist: 0,
		blacklist: 1
	},

	NO_FLICKER_TYPE: {
		off: 0,
		on: 1,
		auto: 2
	},

	BOOLEAN: "boolean",
	INTEGER: "integer",
	STRING: "string",
	RESET: "reset",

	UPDATE_ENABLED: "updateEnabled",

	ENABLED_ROOT: "extensions.yarip.enabled.",
	ENABLED: "extensions.yarip.enabled.value",
	MODE_ROOT: "extensions.yarip.mode.",
	MODE: "extensions.yarip.mode.value",
	RELOAD_ROOT: "extensions.yarip.reload.",
	RELOAD: "extensions.yarip.reload.value",
	NO_FLICKER_ROOT: "extensions.yarip.noFlicker.",
	NO_FLICKER: "extensions.yarip.noFlicker.value",
	ALWAYS_USE_INDEX_ROOT: "extensions.yarip.alwaysUseIndex.",
	ALWAYS_USE_INDEX: "extensions.yarip.alwaysUseIndex.value",
	VALUE: "value",

	PROFILE: "extensions/yarip@mozdev.org",
	XPATH: "extensions/yarip@mozdev.org/xpath.xml",

	CHARSET: "UTF-8",

	address: null,
	undoObj: {},
	noFlicker: 2,
	alwaysUseIndex: true,

	$: function(id)
	{
		return document.getElementById(id);
	}
}

yarip.IP_LITERAL = "(\\[((([a-f\\d]{1,4}:){6}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(::([a-f\\d]{1,4}:){5}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(([a-f\\d]{1,4})?::([a-f\\d]{1,4}:){4}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|((([a-f\\d]{1,4}:)?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){3}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,2})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){2}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,3})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,4})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,5})?[a-f\\d]{1,4})?::[a-f\\d]{1,4})|(((([a-f\\d]{1,4}:){1,6})?[a-f\\d]{1,4})?::))\\])";
yarip.IPV4ADDRESS = "((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5]))";
yarip.IP = "(" + yarip.IPV4ADDRESS + "|" + yarip.IP_LITERAL + ")";
yarip.AUTHORITY = "([a-z\\d]([\\w-.~!$&*+,=:]|%[a-f\\d]{2})*@)?";
yarip.REG_NAME = "([a-z\\d]([\\w-~!$&*+,=@]|%[a-f\\d]{2})+\\.)+";
yarip.HOSTNAME = "[a-z\\d]([\\w-.~!$&'()*+,;=]|%[a-f\\d]{2})+\\.";
yarip.SLD = "[a-z\\d]([\\w-~!$&'()*+,;=]|%[a-f\\d]{2})+\\.";
yarip.TLD = "(ac|ad|aero|ae|af|ag|ai|al|am|an|ao|aq|arpa|ar|asia|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|biz|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|cat|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|coop|com|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|info|int|in|io|iq|ir|is|it|je|jm|jobs|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mil|mk|ml|mm|mn|mobi|mo|mp|mq|mr|ms|mt|museum|mu|mv|mw|mx|my|mz|name|na|nc|net|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pro|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tel|tf|tg|th|tj|tk|tl|tm|tn|to|tp|travel|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|xn--0zwm56d|xn--11b5bs3a9aj6g|xn--80akhbyknj4f|xn--9t4b11yi5a|xn--deba0ad|xn--g6w251d|xn--hgbk6aj7f53bba|xn--hlcj6aya9esc7a|xn--jxalpdlp|xn--kgbechtv|xn--zckzah|ye|yt|yu|za|zm|zw)";
yarip.PATH = "([;/]([\\w-.~!$&'()*+,;=:@/]|%[a-f\\d]{2})*)?";
yarip.QUERY_FRAGMENT = "([&?]([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?(#([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?";

yarip.noSchemeRegExp = new RegExp("(" + yarip.AUTHORITY + "(" + yarip.IP + "|(" + yarip.REG_NAME + yarip.TLD + "\\b))(:\\d+)?" + yarip.PATH + yarip.QUERY_FRAGMENT + ")", "i");
yarip.domainRegExp = new RegExp("\\b(" + yarip.IP + "|(" + yarip.HOSTNAME + yarip.TLD + "))\\b", "i");
yarip.sldRegExp = new RegExp("(" + yarip.IP + "|(" + yarip.SLD + yarip.TLD + "))$", "i");

yarip.getAddress = function(doc, mode)
{
	if (!doc || typeof mode != "number") return null;
	var address = null;
	try
	{
		switch(mode)
		{
			case yarip.MODES.page:
				address = doc.location.protocol + "//" + doc.location.host + doc.location.pathname;
				break;
			case yarip.MODES.fqdn:
				address = doc.location.hostname;
				break;
			case yarip.MODES.sld:
				var sld = doc.location.hostname.match(yarip.sldRegExp);
				if (sld) address = sld[0];
				break;
			case yarip.MODES.user:
				address = yarip.address;
		}
		if (address == "") address = null;
	}
	catch(e){}
	return address;
}

yarip.getAddressArray = function(doc, pages)
{
	var aAddress = [];

	var tmpDomain = null;

	var reduceDomain = yarip.getAddress(doc, yarip.MODES.page);
	while (reduceDomain != tmpDomain)
	{
		var tmpPath = null;
		var reducePath = reduceDomain;

		while (reducePath != tmpPath)
		{
			if (pages[reducePath]) aAddress.push(reducePath);
			tmpPath = reducePath;
			reducePath = reducePath.replace(/(\/|[^/]*)$/, "");
		}

		tmpDomain = reduceDomain;
		reduceDomain = reduceDomain.replace(/^([^:]+:\/\/|[^.]+\.)/, "");
	}

	return aAddress;
}

yarip.resetOnAddress = function(doc, pages, address, xpath, show)
{
	if (!doc || !pages || !address) return false;

	var whitelist = pages[address] ? pages[address].whitelist : null;
	var blacklist = pages[address] ? pages[address].blacklist : null;

	if (!xpath)
	{
		if (whitelist) for (var xValue in whitelist.xpaths) if (whitelist.xpaths[xValue]) yarip.resetOnAddress(doc, pages, address, whitelist.xpaths[xValue]);
		if (blacklist) for (var xValue in blacklist.xpaths) if (blacklist.xpaths[xValue]) yarip.resetOnAddress(doc, pages, address, blacklist.xpaths[xValue]);
		return true;
	}

	if (show)
	{
		var elements = yarip.getElementsByXPath(doc, xpath.value);
		if (elements) for (var i = 0; i < elements.snapshotLength; i++)
		{
			var element = elements.snapshotItem(i);
			switch (element.getAttribute("status"))
			{
				case "whitelisted":
				case "blacklisted":
					element.removeAttribute("status");
			}
		}
	}

	if (whitelist) whitelist.remove(xpath);
	if (blacklist) blacklist.remove(xpath);
	yarip.undoObj[xpath.value] = null;

	return true;
}

yarip.whitelist = function(doc, pages, address, xpath, isNew)
{
	if (!doc || !pages || !address || !xpath) return false;

	var elements = yarip.getElementsByXPath(doc, xpath.value);
	if (!elements) return false;

	var whitelist = pages[address] ? pages[address].whitelist : null;

	var found = false;
	for (var i = 0; i < elements.snapshotLength; i++)
	{
		var element = elements.snapshotItem(i);

		if (element.getAttribute("status") == "whitelisted") continue;

		if (isNew) element.setAttribute("status", "whitelisted");
		else while (element && element.nodeType == 1 && element.getAttribute("status") != "whitelisted")
		{
			element.setAttribute("status", "whitelisted");
			element = element.parentNode;
		}

		found = true;
	}
	if (found && isNew)
	{
		if (!pages[address]) pages[address] = new yarip.Page(address);
		pages[address].whitelist.add(xpath);
		var obj = {}
		obj.document = doc;
		obj.address = address;
		obj.xValue = xpath.value;
		obj.type = yarip.TYPE.whitelist;
		yarip.undoObj[xpath.value] = obj;
	}
	return found;
}

yarip.blacklist = function(doc, pages, address, xpath, isNew, force)
{
	if (!doc || !pages || !address || !xpath) return false;

	var elements = yarip.getElementsByXPath(doc, xpath.value);
	if (!elements) return false;

	var blacklist = pages[address] ? pages[address].blacklist : null;

	var found = false;
	for (var i = 0; i < elements.snapshotLength; i++)
	{
		var element = elements.snapshotItem(i);

		if (!force && element.getAttribute("status") == "whitelisted")
		{
			if (blacklist && blacklist.xpaths[xpath.value])
			{
				blacklist.xpaths[xpath.value].notRemoved++; // increment `not removed'
				found = true; // changes made
			}
			continue;
		}

		element.setAttribute("status", "blacklisted");
		if (!isNew)
		{
			if (element.localName.match(/^i?frame$/i)) element.setAttribute("src", "about:blank");
			else element.innerHTML = "";
		}
		found = true;
	}

	if (found && isNew)
	{
		if (!pages[address]) pages[address] = new yarip.Page(address);
		pages[address].blacklist.add(xpath);
		var obj = {}
		obj.document = doc;
		obj.address = address;
		obj.xValue = xpath.value;
		obj.type = yarip.TYPE.blacklist;
		yarip.undoObj[xpath.value] = obj;
	}

	return found;
}

yarip.calculateXPath = function(element, fullPath)
{
	if (!element) return null;

	var xValue = "";
	do
	{
		var attributes = "";

		if (element.getAttribute("id"))
		{
			attributes += "[@id='" + element.getAttribute("id") + "']";
			if (!fullPath) return "//" + element.localName.toLowerCase() + attributes + xValue; // shortest xpath
		}
		else
		{
			if (element.getAttribute("name")) attributes += "@name='" + element.getAttribute("name") + "' and ";
			if (element.getAttribute("class")) attributes += "@class='" + element.getAttribute("class") + "' and ";
			if (attributes != "") attributes = "[" + attributes.substring(0, attributes.length - 5) + "]";

			if (element.localName && !element.localName.match(/^(html|head|title|body|thead|tbody|tfoot|frameset)$/i))
			{
				var index = 1;
				var sibling = element.previousSibling;
				while (sibling)
				{
					if (sibling.localName && element.localName && sibling.localName.toLowerCase() == element.localName.toLowerCase()) ++index;
					sibling = sibling.previousSibling;
				}

				var found = false;
				sibling = element.nextSibling;
				while (!found && sibling)
				{
					if (sibling.localName && element.localName && sibling.localName.toLowerCase() == element.localName.toLowerCase()) found = true;
					else sibling = sibling.nextSibling;
				}
				if (found || index > 1 || yarip.alwaysUseIndex) attributes = "[" + index + "]" + attributes;
			}
		}

		xValue = "/" + element.localName.toLowerCase() + attributes + xValue;

		element = element.parentNode;
	} while (element && element.nodeType == 1);

	return xValue != "" ? xValue : null;
}

yarip.getElementsByXPath = function(doc, xValue)
{
	var elements = null;
	try
	{
		elements = doc.evaluate(xValue, doc, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	}
	catch(e)
	{
		var consoleService = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
		var scriptError = Components.classes['@mozilla.org/scripterror;1'].createInstance(Components.interfaces.nsIScriptError);
		var message = "Malformed XPath: " + xValue;
		var sourceName = "chrome://yarip/content/yarip.js";
		scriptError.init(message, sourceName, null, e.lineNumber, e.columnNumber, scriptError.errorFlag, "content javascript");
		consoleService.logMessage(scriptError);
	}
	if (!elements || elements.snapshotLength == 0) return null;
	return elements;
}

yarip.normalSort = function(a, b) {
	if (a < b) return -1;
	if (a > b) return 1;
	return 0;
}
